"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.base64ToUint8Array = exports.base64ToArrayBuffer = exports.arrayBufferToBase64 = void 0;
function arrayBufferToBase64(buffer) {
    let binary = '';
    let bytes = new Uint8Array(buffer);
    let len = bytes.byteLength;
    for (let i = 0; i < len; i++) {
        binary += String.fromCharCode(bytes[i]);
    }
    return btoa(binary);
}
exports.arrayBufferToBase64 = arrayBufferToBase64;
function base64ToArrayBuffer(base64) {
    const rawBytes = atob(base64);
    const uint8Array = new Uint8Array(rawBytes.length);
    for (let i = 0; i < rawBytes.length; i++) {
        uint8Array[i] = rawBytes.charCodeAt(i);
    }
    return uint8Array.buffer;
}
exports.base64ToArrayBuffer = base64ToArrayBuffer;
function base64ToUint8Array(base64) {
    const rawBytes = atob(base64);
    const uint8Array = new Uint8Array(rawBytes.length);
    for (let i = 0; i < rawBytes.length; i++) {
        uint8Array[i] = rawBytes.charCodeAt(i);
    }
    return uint8Array;
}
exports.base64ToUint8Array = base64ToUint8Array;
//# sourceMappingURL=utils.js.map