var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, array, struct, option } from '@race-foundation/borsh';
export var VoteType;
(function (VoteType) {
    VoteType[VoteType["ServerVoteTransactorDropOff"] = 0] = "ServerVoteTransactorDropOff";
    VoteType[VoteType["ClientVoteTransactorDropOff"] = 1] = "ClientVoteTransactorDropOff";
})(VoteType || (VoteType = {}));
export class Token {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
export class TokenWithBalance {
    constructor(token, amount) {
        Object.assign(this, token);
        this.amount = amount;
        this.uiAmount = (Number(amount) / Math.pow(10, token.decimals)).toLocaleString();
    }
}
export class ServerAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], ServerAccount.prototype, "addr", void 0);
__decorate([
    field('string')
], ServerAccount.prototype, "endpoint", void 0);
export class PlayerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], PlayerJoin.prototype, "addr", void 0);
__decorate([
    field('u16')
], PlayerJoin.prototype, "position", void 0);
__decorate([
    field('u64')
], PlayerJoin.prototype, "balance", void 0);
__decorate([
    field('u64')
], PlayerJoin.prototype, "accessVersion", void 0);
__decorate([
    field('string')
], PlayerJoin.prototype, "verifyKey", void 0);
export class ServerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], ServerJoin.prototype, "addr", void 0);
__decorate([
    field('string')
], ServerJoin.prototype, "endpoint", void 0);
__decorate([
    field('u64')
], ServerJoin.prototype, "accessVersion", void 0);
__decorate([
    field('string')
], ServerJoin.prototype, "verifyKey", void 0);
export class PlayerDeposit {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], PlayerDeposit.prototype, "addr", void 0);
__decorate([
    field('u64')
], PlayerDeposit.prototype, "amount", void 0);
__decorate([
    field('u64')
], PlayerDeposit.prototype, "settleVersion", void 0);
export class Vote {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], Vote.prototype, "voter", void 0);
__decorate([
    field('string')
], Vote.prototype, "votee", void 0);
__decorate([
    field('u8')
], Vote.prototype, "voteType", void 0);
export class GameAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], GameAccount.prototype, "addr", void 0);
__decorate([
    field('string')
], GameAccount.prototype, "title", void 0);
__decorate([
    field('string')
], GameAccount.prototype, "bundleAddr", void 0);
__decorate([
    field('string')
], GameAccount.prototype, "tokenAddr", void 0);
__decorate([
    field('string')
], GameAccount.prototype, "ownerAddr", void 0);
__decorate([
    field('u64')
], GameAccount.prototype, "settleVersion", void 0);
__decorate([
    field('u64')
], GameAccount.prototype, "accessVersion", void 0);
__decorate([
    field(array(struct(PlayerJoin)))
], GameAccount.prototype, "players", void 0);
__decorate([
    field(array(struct(PlayerDeposit)))
], GameAccount.prototype, "deposits", void 0);
__decorate([
    field(array(struct(ServerJoin)))
], GameAccount.prototype, "servers", void 0);
__decorate([
    field(option('string'))
], GameAccount.prototype, "transactorAddr", void 0);
__decorate([
    field(array(struct(Vote)))
], GameAccount.prototype, "votes", void 0);
__decorate([
    field(option('u64'))
], GameAccount.prototype, "unlockTime", void 0);
__decorate([
    field('u16')
], GameAccount.prototype, "maxPlayers", void 0);
__decorate([
    field('u64')
], GameAccount.prototype, "minDeposit", void 0);
__decorate([
    field('u64')
], GameAccount.prototype, "maxDeposit", void 0);
__decorate([
    field('u32')
], GameAccount.prototype, "dataLen", void 0);
__decorate([
    field('u8-array')
], GameAccount.prototype, "data", void 0);
export class GameBundle {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], GameBundle.prototype, "uri", void 0);
__decorate([
    field('string')
], GameBundle.prototype, "name", void 0);
__decorate([
    field('u8-array')
], GameBundle.prototype, "data", void 0);
export class GameRegistration {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], GameRegistration.prototype, "title", void 0);
__decorate([
    field('string')
], GameRegistration.prototype, "addr", void 0);
__decorate([
    field('u64')
], GameRegistration.prototype, "regTime", void 0);
__decorate([
    field('string')
], GameRegistration.prototype, "bundleAddr", void 0);
export class RegistrationAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], RegistrationAccount.prototype, "addr", void 0);
__decorate([
    field('bool')
], RegistrationAccount.prototype, "isPrivate", void 0);
__decorate([
    field('u16')
], RegistrationAccount.prototype, "size", void 0);
__decorate([
    field(option('string'))
], RegistrationAccount.prototype, "owner", void 0);
__decorate([
    field(array(struct(GameRegistration)))
], RegistrationAccount.prototype, "games", void 0);
/**
 * The registration account data with games consolidated.
 */
export class RegistrationWithGames {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
export class PlayerProfile {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], PlayerProfile.prototype, "addr", void 0);
__decorate([
    field('string')
], PlayerProfile.prototype, "nick", void 0);
__decorate([
    field(option('string'))
], PlayerProfile.prototype, "pfp", void 0);
//# sourceMappingURL=accounts.js.map