import { RandomSpec } from './random-state';
import { HandleError } from './error';
import { GameContext } from './game-context';
import { Fields } from './types';
export declare abstract class SettleOp {
}
export declare class SettleAdd extends SettleOp {
    amount: bigint;
    constructor(fields: Fields<SettleAdd>);
}
export declare class SettleSub extends SettleOp {
    amount: bigint;
    constructor(fields: Fields<SettleAdd>);
}
export declare class SettleEject extends SettleOp {
    constructor(_: any);
}
export declare class Settle {
    addr: string;
    op: SettleOp;
    constructor(fields: {
        addr: string;
        op: SettleOp;
    });
    sortKey(): number;
    compare(s: Settle): number;
}
export declare class Ask {
    playerAddr: string;
    constructor(fields: Fields<Ask>);
}
export declare class Assign {
    randomId: number;
    playerAddr: string;
    indexes: number[];
    constructor(fields: Fields<Assign>);
}
export declare class Reveal {
    randomId: number;
    indexes: number[];
    constructor(fields: Fields<Reveal>);
}
export declare class Release {
    decisionId: number;
    constructor(fields: Fields<Release>);
}
export declare class ActionTimeout {
    playerAddr: string;
    timeout: bigint;
    constructor(fields: Fields<ActionTimeout>);
}
export declare class Effect {
    actionTimeout: ActionTimeout | undefined;
    waitTimeout: bigint | undefined;
    startGame: boolean;
    stopGame: boolean;
    cancelDispatch: boolean;
    timestamp: bigint;
    currRandomId: number;
    currDecisionId: number;
    playersCount: number;
    serversCount: number;
    asks: Ask[];
    assigns: Assign[];
    reveals: Reveal[];
    releases: Release[];
    initRandomStates: RandomSpec[];
    revealed: Map<number, Map<number, string>>;
    answered: Map<number, string>;
    settles: Settle[];
    handlerState: Uint8Array | undefined;
    error: HandleError | undefined;
    allowExit: boolean;
    checkpoint: boolean;
    constructor(fields: Fields<Effect>);
    static fromContext(context: GameContext): Effect;
}
//# sourceMappingURL=effect.d.ts.map